searchNodes=[{"doc":"Cross-module type validation. This compiler reports all type violations. Usage Once you have Tyx used anywhere in your project, you need to include the compiler in mix.exs : defmodule MyApp.MixProject do # ... def project do [ compilers : [ :tyx | Mix . compilers ( ) ] , # ... ] end # ... end When developing a library, it's advised to use this compiler only in :dev and :test environments: defmodule MyLib.MixProject do # ... def project do [ compilers : extra_compilers ( Mix . env ( ) ) ++ Mix . compilers ( ) , # ... ] end # ... defp extra_compilers ( :prod ) , do : [ ] defp extra_compilers ( _env ) , do : [ :tyx ] end Warnings Every invalid type is reported as a compiler warning. Consider the following example: defmodule MyApp.User do use Tyx deft auth ( name : String , pass : String , OUT : :ok ) do MyApp.Auth . validate ( name , pass ) end end Assuming that MyApp.Auth.validate/2 might fail returning {:error, _} tuple, you'll get the following warning: $ mix compile warning : type violation in ` MyApp.User . auth / 2 ` ( returned value ` { :error , _ } ` is not allowed ) lib / my_app / user . ex : 3 Since the compiler emits warnings, mix compile will still succeed, and you can normally start your system, even if some type checks has not succeeded. The compiler doesn’t force you to immediately fix these type errors, which is a deliberate decision made to avoid disrupting the development flow. At the same time, it's worth enforcing types on the CI. This can easily be done by providing the --warnings-as-errors option to mix compile .","ref":"Mix.Tasks.Compile.Tyx.html","title":"Mix.Tasks.Compile.Tyx","type":"task"},{"doc":"Tyx","ref":"Tyx.html","title":"Tyx","type":"module"},{"doc":"","ref":"Tyx.html#deft/2","title":"Tyx.deft/2","type":"macro"},{"doc":"Tests for deft/2 .","ref":"Tyx.Deft.html","title":"Tyx.Deft","type":"module"},{"doc":"","ref":"Tyx.Deft.html#ko1/2","title":"Tyx.Deft.ko1/2","type":"function"},{"doc":"","ref":"Tyx.Deft.html#ko2/2","title":"Tyx.Deft.ko2/2","type":"function"},{"doc":"","ref":"Tyx.Deft.html#ok/2","title":"Tyx.Deft.ok/2","type":"function"},{"doc":"Getting Started","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"The standard Elixir syntax does not change much. One declares types for parameters using ~&gt; Type syntax and the return type using ~&gt;&gt; Type syntax. deft my_take ( list ~&gt; List , count ~&gt; Integer ) ~&gt;&gt; List do Enum . take ( list , count ) end During compilation stage the above would not produce warnings, while the same declared to return ~&gt;&gt; Integer would.","ref":"getting-started.html#syntax","title":"Getting Started - Syntax","type":"extras"}]